volatile unsigned int* comparison_module_reg = (unsigned int*) 0x08000000;
volatile unsigned int* comparison_module_reg_0 = (unsigned int*) 0x08000000;
volatile unsigned int* comparison_module_reg_1 = (unsigned int*) 0x08000004;
volatile unsigned int* comparison_module_reg_2 = (unsigned int*) 0x08000008;
volatile unsigned int* comparison_module_reg_3 = (unsigned int*) 0x0800000c;
volatile unsigned int* comparison_module_reg_4 = (unsigned int*) 0x08000010;

#define COMMAND_OFFSET 0x08000000
#define X_OFFSET 0x00020000
#define OFFSET 0x00000100
#define VALUE 0x00000001

// Wait until done
int wait_until_done(volatile int* poll_address, volatile int* ak_address)
{
	int a;
	int value = *poll_address;
	
	while ( ( value & 0xff000000 ) != 0xaa000000 )
		value = *poll_address;

	*ak_address = (0xa0000000);
	return ( value & 0x00ffffff );
};

// Gaussian distribution LUT
int gaussian( int delta )
{
  if ( delta < 1 )
    return 255;
  else if ( delta < 4 )
    return 250;
  else if ( delta < 9 )
    return 245;
  else if ( delta < 25 )
    return 230;
  else if ( delta < 49 )
    return 215;
  else if ( delta < 81 )
    return 196;
  else if ( delta < 121 )
    return 188;
  else if ( delta < 196 )
    return 180;
  else if ( delta < 289 )
    return 168;
  else if ( delta < 400 )
    return 157;
  else if ( delta < 576 )
    return 124;
  else if ( delta < 784 )
    return 110;
  else if ( delta < 1089 )
    return 99;
  else if ( delta < 1444 )
    return 74;
  else if ( delta < 2025 )
    return 55;
  else if ( delta < 2704 )
    return 40;
  else
    return 0;
}

//all letters are 5x9 pixles

void write_A ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_B ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_C ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_D ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_E ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_F ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	
};
void write_G ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_H ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_I ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_J ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_K ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_L ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_M ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+5)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_N ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);	
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);	
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_O ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_P ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);	
};
void write_Q ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
};
void write_R ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_S ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_T ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_U ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_V ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_W ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_X ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_Y ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_Z ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_0 ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);	
};
void write_1 ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_2( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_3 ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_4 ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};
void write_5 ( int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+1)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+2)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+3)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+4)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+5)*X_OFFSET)+((y+5)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+5)*X_OFFSET)+((y+6)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+4)*X_OFFSET)+((y+7)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+1)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+2)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
	*comparison_module_reg = (1*COMMAND_OFFSET)+((x+3)*X_OFFSET)+((y+8)*OFFSET)+(1*VALUE);
};

void write_square (int x, int y)
{
	int i;
	for ( i = 0; i < 40; i++ )
	{
		*comparison_module_reg = (1*COMMAND_OFFSET)+((x+i)*X_OFFSET)+((y+0)*OFFSET)+(1*VALUE);
		*comparison_module_reg = (1*COMMAND_OFFSET)+((x+i)*X_OFFSET)+((y+39)*OFFSET)+(1*VALUE);
		*comparison_module_reg = (1*COMMAND_OFFSET)+((x+0)*X_OFFSET)+((y+i)*OFFSET)+(1*VALUE);
		*comparison_module_reg = (1*COMMAND_OFFSET)+((x+39)*X_OFFSET)+((y+i)*OFFSET)+(1*VALUE);
	}
}

int check_square (int x_origin, int y_origin, int x, int y)
{
	if ( ( x >= x_origin ) && ( x < ( x_origin + 40 ) ) && ( y >= y_origin ) && ( y < ( y_origin + 40 ) ) )
		return 1;
	else
		return 0;
}

void write_distribution (int x, int y)
{
	int i, j, delta_x, delta_y, result;
	for ( i = (x-50); i < (x+50); i++ )
	{
		for ( j = (y-50); j < (y+50); j++ )
		{
			if ( (i >= 0) && (j >= 0) && (i < 256) && (j < 256))
			{
				delta_x = i-x;
				delta_y = j-y;
				result = gaussian((delta_x*delta_x)+(delta_y*delta_y));
				*comparison_module_reg = (10*COMMAND_OFFSET)+((i)*X_OFFSET)+((j)*OFFSET);
				if ( wait_until_done(comparison_module_reg_1,comparison_module_reg_0) < result )
					*comparison_module_reg = (3*COMMAND_OFFSET)+((i)*X_OFFSET)+((j)*OFFSET)+(result*VALUE);
			}
		}
	}
}

void write_a_pixel (int x, int y )
{
	*comparison_module_reg = (1*COMMAND_OFFSET)+(x*X_OFFSET)+(y*OFFSET)+(1*VALUE);
}

