////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Yet Another Human Gesture Controller - Keypress Task Program
//
// Author: Rahat Mahmood
// Date: Apr 5, 2011
//
// This program generates keyboard events based on key code received as command line arguments
//
////////////////////////////////////////////////////////////////////////////////////////////////////


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>

#include <X11/extensions/XTest.h>

#include "common.h"

int main(int argc, char* argv[]) {
  
  Display *display;
  unsigned int keycode;
  display = XOpenDisplay(NULL);

  if (argc != 2) {
    printf("Error: Incorrect number of arguments (takes only 1 arg, got %d)\n", argc - 1);
    exit(1);
  }

  /* printf("argc = %d\n", argc); */
  /* printf("argv[0] = %s\n", argv[0]); */
  /* printf("argv[1] = %s\n", argv[1]); */


  int arg = atoi(argv[1]);

  switch(arg) {
  case NEXT_KEY_COMMAND:
    keycode = XKeysymToKeycode(display, XK_Next);
    break;
  case PRIOR_KEY_COMMAND:
    keycode = XKeysymToKeycode(display, XK_Prior);
    break;
  default:
    printf("Error: unrecognized key code\n");
    exit(1);
  }

  //  sleep(5);
  printf("keypress: Sending key with encoding %d\n", arg);

  keycode = XKeysymToKeycode(display, XK_Next);
  XTestFakeKeyEvent(display, keycode, True, 0);
  XTestFakeKeyEvent(display, keycode, False, 0);
  XFlush(display);

  // Clean up
  XCloseDisplay(display);
  exit(EXIT_SUCCESS);

  return EXIT_SUCCESS; // shoudln't get here
}
